package org.oppnet;

import java.io.*;
import java.util.*;

import org.oppnet.OppnetHelper;

import com.icesoft.faces.async.render.SessionRenderer;

/**
 * The ShowStatus class pushes notification to passengers.
 *  
 * @author  Shuai Yue <sy2342@columbia.edu>
 * @version 2010.1216
 *
 * @author  Taotao Li <tl2453@columbia.edu>
 * @version 2011.0518
 */

public class ShowStatus implements Runnable {

	private String availability = "The page you recently requested is not ready, please wait.   ";
	private int oldAmount = 0;
	private Thread statusThread;
	private ArrayList<String> itemList = new ArrayList<String>();
	private static String catalinaHome=OppnetHelper.getInstance().getCatalinaHome();
	private static String tomcatPort = OppnetHelper.getInstance().getTomcatPort();
	public static final String IpAddressFroLAN = OppnetHelper.getInstance().getIpAddressForLAN();
	private String localroot = catalinaHome+"webapps/";
	
	public ShowStatus() {
		statusThread = new Thread(this);
		statusThread.start();
	}

	public synchronized String getAvailability() {
		return availability;
	}

	public synchronized int getOldAmount() {
		return oldAmount;
	}

	public void run() {
		while (true) {
			try {
				
				FileReader fr = new FileReader(localroot + "CacheFiles/CacheTable.txt");
				BufferedReader br = new BufferedReader(fr);
				String line = new String();
				while ((line = br.readLine()) != null) {

					line = line.substring(7, line.length());

					if (!line.contains("/")) {

						itemList.add(line);
					}

				}

				br.close();
				fr.close();

				if (itemList.size() > oldAmount) {

					for (int i = oldAmount; i < itemList.size(); i++) {
						line = itemList.get(i).toString();
						String hrefline = new String();
						
						if (line.endsWith("html")) {
							hrefline = "<a href=\"http://"+IpAddressFroLAN+":"+tomcatPort+"/CacheFiles/"
									+ line
									+ "\" target=\"_parent\"><b>"
									+ line
									+ "</b></a>";
						} else {
							hrefline = "<a href=\"http://"+IpAddressFroLAN+":"+tomcatPort+"/CacheFiles/"
									+ line
									+ ".html"
									+ "\" target=\"_parent\"><b>"
									+ line
									+ "</b></a>";
						}
				                
						FileReader fr1 = new FileReader(localroot + "CacheFiles/MappingTable.txt");
						BufferedReader br1 = new BufferedReader(fr1);
						String line1 = new String();
						String urlPart = new String();
						String ipPart = new String();
						int index = 0;

						while ((line1 = br1.readLine()) != null) {
							index = line1.indexOf(",");
							urlPart = line1.substring(0, index);

							if (urlPart.equals(line)) {
								ipPart = line1.substring(index + 1, line1
										.length());
								availability = hrefline
										+ " is available, you can visit it now!   ";
															
								SessionRenderer.render(ipPart);
								Thread.sleep(10);
							}
							availability = "The page you recently requested is not ready, please wait.   ";
						}

						br1.close();
						fr1.close();
					}
				}

				oldAmount = itemList.size();
				itemList.clear();
				Thread.sleep(10);

			} catch (Exception e) {
				System.err.println(e.getMessage());
			}

		}
	}
}