package org.doit.muffin.filter;

import org.doit.muffin.*;

/**
 * The OppNet class displays the interface of OppNetFilter. This file modifies
 * Mr. Suman Srinivasan's codes
 * 
 * @author Shuai Yue <sy2342@columbia.edu>
 * @version 2010.1216
 * 
 * @author Taotao Li <tl2453@columbia.edu>
 * @version 2011.0518
 */

public class OppNet implements FilterFactory {
	FilterManager manager;
	Prefs prefs;
	OppNetFrame frame = null;
	MessageArea messages = null;

	public void setManager(FilterManager manager) {
		this.manager = manager;
	}

	public void setPrefs(Prefs prefs) {
		this.prefs = prefs;

		boolean o = prefs.getOverride();
		prefs.setOverride(false);
		prefs.putInteger("OppNet.historySize", 500);
		prefs.setOverride(o);

		messages = new MessageArea(prefs.getInteger("OppNet.historySize"));
	}

	public Prefs getPrefs() {
		return prefs;
	}

	public void viewPrefs() {
		if (frame == null) {
			frame = new OppNetFrame(prefs, this);
		}
		frame.setVisible(true);
	}

	public Filter createFilter() {
		Filter f = new OppNetFilter(this);
		f.setPrefs(prefs);
		return f;
	}

	public void shutdown() {
		if (frame != null) {
			frame.dispose();
		}
	}

	void save() {
		manager.save(this);
	}

	void process(String s) {
		messages.append(s);
	}
}
