package org.doit.muffin.filter;

import java.awt.*;
import java.awt.event.*;
import org.doit.muffin.*;

/**
 * The OppNetFrame class displays the interface of OppNetFilter. This file
 * modifies Mr. Suman Srinivasan's codes
 * 
 * @author Shuai Yue <sy2342@columbia.edu>
 * @version 2010.1216
 * 
 * @author Taotao Li <tl2453@columbia.edu>
 * @version 2011.0518
 */

public class OppNetFrame extends MuffinFrame implements ActionListener,
		WindowListener {
	Prefs prefs;
	OppNet parent;

	public OppNetFrame(Prefs prefs, OppNet parent) {
		super("Muffin: OppNet");

		this.prefs = prefs;
		this.parent = parent;

		parent.messages.setEditable(false);
		add("Center", parent.messages);

		Panel buttonPanel = new Panel();
		buttonPanel.setLayout(new GridLayout(1, 3));
		Button b;
		b = new Button("Clear");
		b.setActionCommand("doClear");
		b.addActionListener(this);
		buttonPanel.add(b);
		b = new Button("Close");
		b.setActionCommand("doClose");
		b.addActionListener(this);
		buttonPanel.add(b);
		b = new Button("Help");
		b.setActionCommand("doHelp");
		b.addActionListener(this);
		buttonPanel.add(b);
		add("South", buttonPanel);

		addWindowListener(this);

		pack();
		setSize(getPreferredSize());

		show();
	}

	public void actionPerformed(ActionEvent event) {
		String arg = event.getActionCommand();

		if ("doClose".equals(arg)) {
			setVisible(false);
		} else if ("doClear".equals(arg)) {
			parent.messages.clear();
		} else if ("doHelp".equals(arg)) {
			new HelpFrame("OppNet");
		}
	}

	public void windowActivated(WindowEvent e) {
	}

	public void windowDeactivated(WindowEvent e) {
	}

	public void windowClosing(WindowEvent e) {
		setVisible(false);
	}

	public void windowClosed(WindowEvent e) {
	}

	public void windowIconified(WindowEvent e) {
	}

	public void windowDeiconified(WindowEvent e) {
	}

	public void windowOpened(WindowEvent e) {
	}
}
